package com.example.afrishop_v3.controllers;

import com.example.afrishop_v3.base.Result;
import com.example.afrishop_v3.enums.ResultCodeEnum;
import com.example.afrishop_v3.models.Complain;
import com.example.afrishop_v3.models.TbCfUserInfo;
import com.example.afrishop_v3.repository.ComplainRepository;
import com.example.afrishop_v3.security.services.AuthenticationUser;
import org.springframework.data.domain.PageRequest;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
public class ComplainController {
    private final ComplainRepository repository;
    private final AuthenticationUser user;

    public ComplainController(ComplainRepository repository, AuthenticationUser user) {
        this.repository = repository;
        this.user = user;
    }


    @PostMapping(value ="/saveComplain")
    public Result saveProduct(@ModelAttribute("Complain") Complain complain){

        TbCfUserInfo user = this.user.user();

        if(repository.existsByUserInfoAndPost(user,complain.getPost())){
            return new Result(ResultCodeEnum.VALIDATE_ERROR.getCode(),"Already complained");
        }

        complain.setUserInfo(user);

        repository.save(complain);

        return new Result();
    }

    @GetMapping(value = "/complains")
    //@PreAuthorize("hasAuthority('ADMIN_USER') or hasAuthority('STANDARD_USER')")
    public List<Complain> getList(@RequestParam(value = "pageNo") Integer pageNo, @RequestParam(value = "pageSize") Integer pageSize) {
        return repository.findAll(PageRequest.of(pageNo, pageSize)).toList();
    }
}
