package com.example.afrishop_v3.models;

import com.fasterxml.jackson.annotation.JsonBackReference;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.io.Serializable;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 实体
 * 表名 tb_cf_category
 *
 * @author lipengjun
 * @date 2019-12-26 21:20:36
 */
@Entity
@Getter
@Setter
public class TbCfCategory {

    /**
     * 商品规格ID
     */
    @Id
    private String categoryId;
    /**
     * 规格名称
     */
    private String categoryName;
    /**
     * 规格详情
     */
    private String categoryDesc;
    /**
     * option
     */
    private String option;
    /**
     * 商品ID
     */
    private String itemId;
    /**
     * 排序
     */
    private Integer orderNum;
    /**
     * 删除标志 0：正常 1：已删除
     */
    private Integer delFlag;
    /**
     * 创建时间
     */
    private Date createTime;
    /**
     * 更新时间
     */
    private Date updateTime;

    @OneToMany(mappedBy = "category")
    @OrderBy("optiionSpecies")
    private List<TbCfOption> optionList = new ArrayList<>();

    /**
     * 设置：商品规格ID
     */
    public void setCategoryId(String categoryId) {
        this.categoryId = categoryId;
    }

    /**
     * 获取：商品规格ID
     */
    public String getCategoryId() {
        return categoryId;
    }
    /**
     * 设置：规格名称
     */
    public void setCategoryName(String categoryName) {
        this.categoryName = categoryName;
    }

    /**
     * 获取：规格名称
     */
    public String getCategoryName() {
        return categoryName;
    }
    /**
     * 设置：规格详情
     */
    public void setCategoryDesc(String categoryDesc) {
        this.categoryDesc = categoryDesc;
    }

    /**
     * 获取：规格详情
     */
    public String getCategoryDesc() {
        return categoryDesc;
    }
    /**
     * 设置：option
     */
    public void setOption(String option) {
        this.option = option;
    }

    /**
     * 获取：option
     */
    public String getOption() {
        return option;
    }
    /**
     * 设置：商品ID
     */
    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    /**
     * 获取：商品ID
     */
    public String getItemId() {
        return itemId;
    }
    /**
     * 设置：排序
     */
    public void setOrderNum(Integer orderNum) {
        this.orderNum = orderNum;
    }

    /**
     * 获取：排序
     */
    public Integer getOrderNum() {
        return orderNum;
    }
    /**
     * 设置：删除标志 0：正常 1：已删除
     */
    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

    /**
     * 获取：删除标志 0：正常 1：已删除
     */
    public Integer getDelFlag() {
        return delFlag;
    }
    /**
     * 设置：创建时间
     */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    /**
     * 获取：创建时间
     */
    public Date getCreateTime() {
        return createTime;
    }
    /**
     * 设置：更新时间
     */
    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    /**
     * 获取：更新时间
     */
    public Date getUpdateTime() {
        return updateTime;
    }

    private Integer getSwitched(String str){
        switch (str){
            case "XXS":
                return 1;
            case "XS":
                return 2;
            case "S":
                return 3;
            case "M":
                return 4;
            case "L":
                return 5;
            case "XL":
                return 6;
            case "XXL":
                return 7;
            case "XXXL":
                return 8;
            default:
                return str.matches(".*\\d.*") ? nextInt(str) : 9;
        }
    }

    private int nextInt(String str){
        try {
            Scanner in = new Scanner(str).useDelimiter("[^0-9]+");
            return in.nextInt();
        }catch (Exception e){
            return 9;
        }
    }


    public List<TbCfOption> getOptionList() {
        return optionList.stream().sorted(Comparator.comparing(o -> getSwitched(o.getOptiionSpecies()))).collect(Collectors.toList());
    }
}
